// C Header File


#include <stdio.h>
enum choice {C_START, C_OPT, C_ABOUT, C_EXIT};
enum action { A_ENTER=0x10, A_RIGHT=0x20, A_LEFT=0x40, A_EXIT=0x80, A_TEST=0xf0 };


//#define print_string(x,y,str) DrawStr (x, y, str, A_NORMAL)
void print_string (int x, int y, char* str)
{ DrawStr (x, y, str, A_NORMAL); }



int intro_screen()
{
	int menu (char* title, int argc, char* agrv[]);
	void waitkey();
	void bl_options();
	void about();
	
	int choice= 0, exit= 0;
	
	char* main_menu[]= { "START / RESUME", "OPTIONS", "ABOUT", "EXIT" };
//	char title[20];
//	sprintf (title, "Blocks %s", current_version);
	for (;;)
	{
		choice= menu ("BLOCKS", 4, main_menu);
		if (((choice%16)==C_EXIT) || (choice&A_EXIT) || (choice&A_LEFT)) { exit=1; break; }
		else if ((choice%16)==C_ABOUT)
		{ about(); }
		else if ((choice%16)==C_OPT) { bl_options(); }
		else if ((choice%16)==C_START) { break; }
	}
		
	return exit;
}


void bl_options()
{
	int menu (char* title, int argc, char* agrv[]);
	
	int choice=0;
	char* opt_menu[]= { "CONTRAST /" };
	
	for (;;)
	{
		choice= menu ( "Options", 1, opt_menu);
		if (choice&A_EXIT) { break; }
		if ((choice%16)==0)
		{
			if (choice&A_RIGHT) { OSContrastUp(); }
			if (choice&A_LEFT) { OSContrastDn(); }
		}
	}
}


int menu (char* title, int argc, char* argv[])
{
	void drawblock (int x, int y, int type);
	int quit();

	//enum action { A_ENTER=0x10, A_RIGHT=0x20, A_LEFT=0x40, A_EXIT=0x80 }
	int I, choice=0, keydown= 1;
	PortSet (light_plane, 239, 127);
	ClrScr();
	DrawClipRect (MakeWinRect (0, 0, 159, 99), full_screen, A_NORMAL | B_NORMAL);
	
	PortSet (dark_plane, 239, 127);
	ClrScr();
	DrawClipRect (MakeWinRect (0, 0, 159, 99), full_screen, A_NORMAL | B_DOUBLE);
	FontSetSys (F_8x10);
	print_string (25, 15, title);
	FontSetSys (F_6x8);
	for (I=0; I<argc; I++) { print_string (48, 37+16*I, argv[I]); }
	PortRestore();

	drawblock (4, 4, BL_RIGHT);
	
	while (!(choice>>4))
	{
		int key=getkey();
		if (!keydown)
		{
			keydown=1;
			switch (key)
			{
				case K_UP:
				case K_DOWN:
					drawblock (4, 4+2*choice, BL_VOID);
					if (key==K_UP) { choice--; }
					else { choice++; }
					choice+= argc;
					choice%= argc;
					drawblock (4, 4+2*choice, BL_RIGHT);
					keydown= 1;
					break;
				case K_LEFT:
					choice|= A_LEFT;
					break;
				case K_RIGHT:
					choice|= A_RIGHT;
					break;
				case K_ENTER:
					choice|= A_ENTER;
					break;
				case K_ESC:
					choice|= A_EXIT;
					break;
				case K_NONE:
					keydown=0;
			}
				
		}
		else if (!key) { keydown=0; }
	}
	
	return choice;
}

void about()
{
	void clr_dn_scr()
	{
		PortSet (light_plane, 239, 127);
		ScrRectFill (&(SCR_RECT){{2,25,157,95}}, full_screen, A_REVERSE);
		PortSet (dark_plane, 239, 127);
		ScrRectFill (&(SCR_RECT){{2,25,157,95}}, full_screen, A_REVERSE);
	}
	
	clr_dn_scr();
	FontSetSys (F_8x10);
	print_string(25, 30, "Ze Schiebener");
	FontSetSys (F_4x6);
	print_string(25, 45, "(Von german schieben=push)");
	print_string(10, 57, "Because mainly written in german class ;-)");
	print_string(60, 80, "Version 0.99");
	print_string(25, 90, "Compiled on 30/11/00 with Ti-GCC");
	waitkey();
	clr_dn_scr();
	FontSetSys (F_6x8);
	print_string(35, 40, "Main coder:");
	print_string(48, 50, "Dark Angel");
	print_string(35, 70, "Gfx, level design:");
	print_string(48, 80, "Racin");
	waitkey();
	clr_dn_scr();
	FontSetSys (F_4x6);
	print_string(15, 40, "Thanks to:");
	print_string(28, 50, "Ueyo!, Florent, Thierry & others");
	print_string(28, 58, "who made some levels");
	print_string(28, 70, "Zeljko Juric & the Ti-GCC team");
	print_string(32, 78, "& the Doors Team");
	print_string(28, 86, "who made this possible");
	waitkey();
}